; Mand.asm mandPlotter, in Pila, for Palm m100

; Mand eats batteries, but hotsync'g for debugging eats more(!)
; we gotta find a quicker tool, on-board asemblin'g would save us
; gotta try pilot-link, can we just 'mount' the palm, and copy
; the 500byte file instade of syncing 'everything'?

	appl "mandAsm",'demo'

	include "pilot.inc"
	include "startup.inc"

; TODO: hardware-reg equ file...
; LCD controller regs
rLPICF 	equ $A20
rLVPW  	equ $A05
rLSSA	equ $A00

dREG equ $FFFFF000 ; DragonBall regs

	data
; a5 based global vars:
cr0	dc.w -2<<13
ci0	dc.w -2<<13
dx	dc.w ($28<<9)/160
dy	dc.w ($28<<9)/160

global minX.w
global minY.w
global maxX.w
global maxY.w

	; code
	data ; for modifing operands

drawMand:
	move.l dREG|rLSSA,a0          ;  re-read screen pointer
	; ^ should compile to a 'short' abs load
	move.w #160-1,d7
	move.w ci0(a5),a3
.y
	swap d7
	move.w #$A0-1,d7
	move.w cr0(a5),a2   ; ( c = 'a2'+i'a3' )
.x
	; d0,d1,d2,d3 = (a,b,a^2,b^2) [ z = a+ib, z^2 = (a^2-b^2)+i2ab ]
	; we chk the escape time from z(n)=z(n-1)^2+c
	move.w #33,d6 ; colour counter
	clr.w d0
	clr.w d1
.mLoop
	move.w d0,d2
	muls d2,d2
	asr.l #8,d2
	asr.l #5,d2
	move.w d1,d3
	muls d3,d3
	asr.l #8,d3
	asr.l #5,d3

	muls d0,d1
	asr.l #7,d1 
	asr.l #5,d1 
	add.w a3,d1 ; = 2ab + im

	move.w d2,d0
	sub.w d3,d0
	add.w a2,d0 ; = (a^2-b^2) + re

	add.l d2,d3 ; = norm
	cmp.l #4<<13,d3 ; maxNorm
	; ^^ these are '.l' since squaring result might have escape'd
	; to large nums. it's cheap'r than checking overflow AND hi-word
	; NOTE: using lower prec-fix'd point, would save some cycles
	; (on less bitshifts for example) but would ofcourse decrease
	; zoom'ablility
	dbgt d6,.mLoop

	neg.b d6
	add.b #32,d6

	btst #0,d7
	beq .second
	lsl.b #3,d6
	bclr #3,d6
	move.b d6,d5 ; save pix value
	bra .s0
.second
	lsr.b #1,d6
	or.b d6,d5
	move.b d5,(a0)+
.s0

	;adda.w #($28<<9)/160,a2
	adda.w dx(a5),a2
	dbra d7,.x
	;adda.w #($28<<9)/160,a3
	adda.w dy(a5),a3
	swap d7
	dbra d7,.y
	rts

	code

proc PilotMain(cmd.w, cmdPBP.l, launchFlags.w)
; func args are equ'd as offsets from 'a6' reg
local err.w
local evt.EventType
local oldScreen.l
; and so are 'local's
beginproc
; ^ does 'link a6,#nnnn', for after args/locals
	tst.w cmd(a6)
	bne .Return ; sysAppLaunchCmdNormalLaunch is 0, else, quit

	move.l #dREG,a2

	or.b #$02,rLPICF|dREG
	move.b (dREG|rLVPW),d0
	lsl.b #2,d0
	move.b d0,(dREG|rLVPW)

	move.l dREG|rLSSA,oldScreen(a6)

	systrap MemPtrNew(#12800.l)
	; result in a0

	move.l a0,dREG|rLSSA          ; and set in hardware
;	systrap MemSet(a0.l,#12800.l,#$f0.b)

; memSet: (CLS)
	move.w #(160*80-1),d4
	move.b #$ff,d3
.l0
	move.b d3,(a0)+
	dbra d4,.l0

	jsr drawMand(a5)
;	move.w  #40,d0
;	move.w  #60,d1
;	move.w #140,d2
;	move.w #122,d3
;	bsr xorSqr
;	move.w  #20,d0
;	move.w  #20,d1
;	move.w #110,d2
;	move.w #112,d3
;	bsr xorSqr
;	move.w  #40,d0
;	move.w  #42,d1
;	move.w #41,d2
;	move.w #42,d3
;	bsr xorSqr
;	move.w  #10,d0
;	move.w  #10,d1
;	move.w #11,d2
;	move.w #11,d3
;	bsr xorSqr

.eventLoop
	systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)
	systrap SysHandleEvent(&evt(a6))
	tst.b   d0                      ;handled?
;	bne.s   .eventDone             ;yep

;	call    weHandleEvent(&evt(a6))
;	tst.b   d0                      ;handled?
;        bne.s   .eventDone             ;yep
.eventDone
	cmpi.w  #appStopEvent,evt+EventType.eType(a6) ;time to stop?
	bne.s   .eventLoop             ;nope, loop until it is

	and.b #$fc,rLPICF|dREG
	move.b (dREG|rLVPW),d0
	lsr.b #2,d0
	move.b d0,(dREG|rLVPW)

	move.l oldScreen(a6),dREG|rLSSA

.Return:
	moveq.l   #0,d0
endproc ; PilotMain

; input: (d0,d1).w = x,y, d2, low-nibble = colour
; changes: d0-d3/a3
; side-effect: 4bpp Pixel is plot'd
putPixel:
	move.l dREG|rLSSA,a3 ; read screen pointer
	move.w d1,d3
	lsl.w #6,d3
	lsl.w #4,d1
	add.w d3,d1 ; = yoffset
	lea (a3,d1.w),a3
	lsr.w #1,d0
	lea (a3,d0.w),a3
	bcc .second
	andi.b #$f0,(a3)
	or.b d2,(a3)
	rts
.second
	andi.b #$0f,(a3)
	lsl.w #4,d2
	or.b d2,(a3)
	rts

; xorSqr: xor a rektrangle, 4bpp
; input:  coords  -  (d0,d1) -> (d2,d3) .w
; changes: d0-d5/a1-a4
xorSqr: 
	lsr.w #1,d0
	lsr.w #1,d2
	cmp.w d0,d2
	bne .noRet0
	rts
.noRet0
;	bpl .sk0
;	exg d0,d2
;.sk0
	cmp.w d1,d3
	bne .noRet1
	rts
.noRet1
;	bpl .sk0
;	exg d0,d2
;.sk0
	move.l dREG|rLSSA,a3 ; read screen pointer
	move.w d1,d4
	lsl.w #6,d4
	sub.w d1,d3 ; yCnt
	lsl.w #4,d1
	add.w d4,d1 ; = yoffset
	lea (a3,d1.w),a3
	lea (a3,d2.w),a2 ; ypointers - right
	lea (a3,d0.w),a3 ; - left
	move.l a3,a1    ; xloop pointers - up
	sub.w d0,d2 ; xCnt (bytes)
	move.w d3,d0
	lsl.w #6,d0
	move.w d3,d1
	lsl.w #4,d1
	add.w d0,d1
	lea (a3,d1),a4 ; - down
	; avoid double xor'ing of conrner pixels:
	subq.w #2,d2
	addq.l #1,a4
	addq.l #1,a1

.yLoop
	not.b (a3)
	not.b (a2)
	adda #80,a3
	adda #80,a2
	dbra d3,.yLoop
.xLoop
	not.b (a4)+
	not.b (a1)+
	dbra d2,.xLoop

	rts

proc weHandleEvent(pevt.l)
beginproc
	movea.l pevt(a6),a0             ;a0 = pevt
	cmpi.w  #keyDownEvent,EventType.eType(a0)
	bne  .notKey

	; handle keys:
	cmpi.w #pageDownChr,keyDown.chr(a0)
	bne .l0
	; handle keyDown
	;  ... todo ...
	bra .return
.l0
	cmpi.w #pageUpChr,keyDown.chr(a0)
	bne .notKey
	; handle keyUp todo
	bra .return

.notKey:
	cmpi.w  #penDownEvent,EventType.eType(a0)
	bne .l1
	; xor square
	; maximise borders
;	move.l EventType.screenX(a0),minX(a5) ; save X and Y
;	move.l EventType.screenX(a0),maxX(a5) ; save X and Y
; Endianess matters...
	move.w EventType.screenX(a0),minX(a5) ; save X and Y
	move.w EventType.screenX(a0),maxX(a5) ; save X and Y
	move.w EventType.screenY(a0),minY(a5) ; save X and Y
	move.w EventType.screenY(a0),maxY(a5) ; save X and Y
	bra .return

.l1
	cmpi.w #penUpEvent,EventType.eType(a0)
	bne .l2
;	move.w EventType.screenX(a0),d0
;	move.w EventType.screenY(a0),d1
	move.w minX(a5),d0
	move.w maxX(a5),d2
	move.w minY(a5),d1
	move.w maxX(a5),d3
;	bsr xorSqr
	;todo switch to 2nd event handler
	bra .return
.l2
	cmpi.w #penMoveEvent,EventType.eType(a0)
	bne .l3
	move.w minX(a5),d0
	move.w minY(a5),d1
;	move.w maxX(a5),d2
;	move.w maxY(a5),d3
;	bsr xorSqr_sorted
;	move.w #$00,d2
;	bsr putPixel
	move.w EventType.screenX(a0),d2
	move.w EventType.screenY(a0),d3
	bsr xorSqr
	bra .return
 ; minimise minima, and maximise maxima:
	move.w EventType.screenX(a0),d0
	cmp.w minX(a5),d0  
	bpl .sk0
	move.w d0,minX(a5)
	bra .sk1 ; if we min'd we won't max'm proboably
.sk0
	cmp.w maxX(a5),d0  
	bmi .sk1
	move.w d0,maxX(a5)
.sk1

	move.w EventType.screenY(a0),d0
	cmp.w minY(a5),d0  
	bpl .sk2
	move.w d0,minY(a5)
	bra .sk3 ; if we min'd we won't max'm proboably
.sk2
	cmp.w maxX(a5),d0  
	bmi .sk3
	move.w d0,maxX(a5)
.sk3

.l3 ; not pen Event

.return
endproc





; Must have pref resources (otherwise 'fatal-error', on hotsync even!)
	res	'tver', 1
	dc.b	'1.0', 0

	res	'pref', 1
	dc.w	sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
	dc.l	$1000			; stack size
	dc.l	$1000			; heap size


